<?php

/**
 * validar_aportes actions.
 *
 * @package    nomina
 * @subpackage validar_aportes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class validar_aportesActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by 
tab0.num_doc,
tab0.descripcion ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }


            $mensajeError = "";

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            $tag_error = false;


            /*
             * Consulta para determinar funcionarios con Doble descuento de salud o pension - 20160218/20211001
             * Se valida solo planilla tipo A, y se agrega por concepto de nomina tambien, ya que para pension tiene 2 registros por FSP - 20211027
             */
            $sql = <<<EOD
select 

count(tab0.id_liquida_aporte) as cant,
tab0.num_doc,
tab0.id_tipo_doc,
tab0.nombre_completo,
tab0.id_clase_fondo,
tab0.id_mae_fondos,
tab0.descripcion,
tab0.id_concep_nomina

from(
   
    select 
    liq.*,
    cla.descripcion,
    dat.nombre_completo
    from no_liquida_aporte liq
    left join no_datos_funcionario_v dat 
    on liq.id_tipo_doc = dat.id_tipo_doc
    and liq.num_doc = dat.num_doc
    left join no_clase_fondo cla
    on liq.id_clase_fondo = cla.id_clase_fondo

    where
    liq.id_periodo = $periodo_filtro 
    and liq.tipo_planilla = 'A'

)tab0    

where 1 = 1

$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc


having
count(tab0.id_liquida_aporte) > 1

group by
tab0.num_doc,
tab0.id_tipo_doc,
tab0.nombre_completo,
tab0.id_clase_fondo,
tab0.id_mae_fondos,
tab0.descripcion,
tab0.id_concep_nomina

$sortBy
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            if (count($resultado) > 0) {

                $mensajeError .= "<br><br>Existen funcionarios con doble descuento de aporte, favor verificar liquidación de aportes.<br> Para los Funcionarios ::<br>  ";
                foreach ($resultado as $value) {
                    $mensajeError .= "<br>" . $value['nombre_completo'] . ", tipo aporte : " . $value['descripcion'];
                }

                $tag_error = true;
            }


            if ($tag_error) {
                $mensajeError .= "<br>";
                $this->status = 3;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[validar_liquidacion] " . $mensajeError);
            } else {
                $this->status = 0;
                $this->totalRows = 0;
                $this->startRow = 0;
                $this->endRow = 0;
                $this->list_data = array();
                $this->logMessage("[validar_liquidacion] Validación exitosa.");
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
